#!/usr/bin/env python
# -*- coding: iso-8859-1 -*-

"""

=====================
build_firstname_id.py
=====================

DESCRIPTION
===========

generation de la partie "prnom" de l'id


SEE ALSO
========

:ref:`firstname_id.xsl`

EXAMPLES
========

cf. doctest

::

    python -v build_firstname_id

TODO
====

EVOLUTIONS
==========

$Id$

$URL$

- fplod 20120409

  * creation

"""

import string
import sys

def build_firstname_id(firstname):


    """
    >>> firstname = []
    []
    >>> firstname.append(' Ginette')
    [' Ginette']
    >>> firstname.append('Gin ette ')
    [' Ginette', 'Gin  ette']
    >>> firstname.append("G\'in ette ")
    [' Ginette', 'Gin ette', "G\'in ette"]
    >>> firstname_id = build_firstname_id(firstname)
    ['ginette','ginette','ginette']
    """

    if len(firstname) == 0:
        print('eee : firstname empty')
        sys.exit(-1)

    # convert to str
    #++firstname_str = [str(item) for item in firstname]
    #++firstname_str = [item.encode('iso-8859-1','replace') for item in firstname]
    firstname_str = [item.encode('iso-8859-1','xmlcharrefreplace') for item in firstname]
    for item in firstname:
        print ('iii : item type %s : %s ' % (item, type(item)))

    # remove white space before and after
    firstname_id = map(str.strip,firstname_str)
    #print ('1 sans blan debut fin %s' % firstname_id)
    #
    # lower
    firstname_id = map(str.lower,firstname_id)
    #print ('2 upper %s' % firstname_id)
    #
    # remove white space inside
    firstname_id_no_spaces = [x.replace(' ', '') for x in firstname_id]
    #print ('3 sans blanc milieu %s' % firstname_id_no_spaces)
    firstname_id = firstname_id_no_spaces
    #
    # remove punctuation
    for c in string.punctuation:
        firstname_id_no_punctuation = [x.replace(c, '') for x in firstname_id]
        #print ('4 sans %s avec replace string.punctuation %s' % (c, firstname_id_no_punctuation))
        firstname_id = firstname_id_no_punctuation

    return firstname_id

if __name__ == "__main__":
    import doctest
    doctest.testmod()
